import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
public class Arraz<T extends Object> {

    private T[] array;

    public Arraz(T[] arr) {
        array = arr;
    }
    public Arraz() {
    }
    public Integer sumInteger() {
        Integer sum = 0;
        for(int i = 0; i < array.length; i ++){
            sum += (Integer)array[i];
        }
        return sum;
    }
    public Integer sumInteger(Integer[] array) {
        Integer sum = 0;
        for(int i = 0; i < array.length; i ++){
            sum += array[i];
        }
        return sum;
    }
    public Double sumDouble(){
        Double sum = 0.0;
        for(int i = 0; i < array.length; i ++){
            sum += (Double)array[i];
        }
        return sum;
    }
    public Integer avgInteger() {
        Integer sum = sumInteger();
        return sum/array.length;
    }
    public Double avgInteger(Integer[] array) {
        Integer sum = sumInteger(array);
        return (double) sum / (double) array.length;
    }
    public Double avgDouble() {
        Double sum = sumDouble();
        return sum/array.length;
    }
    public boolean contains(Integer i) {
        for (T anArray : array) {
            if (anArray.equals(i)) {
                return true;
            }
        }
        return false;
    }
    public Integer[] reverse() {
        Integer[] newArr = new Integer[array.length];
        for(int i = 0; i < array.length; i ++){
            newArr[(array.length - 1) - i] = (Integer) array[i];
        }
        return newArr;
    }
    public Integer[] reverse(Integer[] array) {
        Integer[] newArr = new Integer[array.length];
        for(int i = 0; i < array.length; i ++){
            newArr[(array.length - 1) - i] = (Integer) array[i];
        }
        return newArr;
    }
    public OddEven getOddEvenes() {
        OddEven answer = new OddEven();
        for(T in : array){
            if((Integer) in % 2 == 0){
                answer.increaseEvens();
            } else{
                answer.increaseOdds();
            }
        }
        return answer;
    }
    public int indexOf(T aba) {
        for(int i = 0; i < array.length; i ++){
            if(array[i].equals(aba)){
                return i;
            }
        }
        return -1;
    }
    public Integer[] copyIterator() {
        Integer[] newArr = new Integer[array.length];
        Iterator<T> it = Arrays.asList(this.array).iterator();
        int i = 0;
        while(it.hasNext()){
            Integer element = (Integer) it.next();
            newArr[i] = element;
            i++;
        }
        return newArr;
    }
    public Integer[] copyLoop() {
        Integer[] newArr = new Integer[array.length];
        for(int i = 0; i < array.length; i ++){
            newArr[i] = (Integer) array[i];
        }
        return newArr;
    }
    public T[] removeElement(T abba) {
        boolean removed = false;
        T[] newInt = Arrays.copyOf(array, array.length - 1);
        for(int i = 0; i < newInt.length; i ++){
            if(array[i].equals(abba)){
                removed = true;
            }
            if(removed){
                newInt[i] = array[i + 1];
            } else {
                newInt[i] = array[i];
            }
        }
        return newInt;
    }
    public T[] insertElement(int i, T element) {
        boolean added = false;
        T[] newInt = Arrays.copyOf(array, array.length + 1);
        for(int n = 0; n < newInt.length; n ++){
            if(n == i){
                added = true;
                newInt[n] = element;
                continue;
            }
            if(added){
                newInt[n] = array[n - 1];
            } else {
                newInt[n] = array[n];
            }
        }
        return newInt;
    }
    public MaxMin getMaxMin() {
        Integer max = 0;
        for(T in : array){
            if((Integer) in > max){
                max = (Integer)in;
            }
        }
        Integer min = max;
        for(T in : array){
            if((Integer) in < min){
                min = (Integer) in;
            }
        }
        return new MaxMin(max, min);
    }
    public Integer[] removeDuplicates() {
        Integer[] newArr = createEmptyArrayWithOutDuplicatesNotExact(2);
        int index = 0;
        for (int i = 0; i < array.length; i++) {
            Integer number = (Integer)array[i];
            int amount = findDuplicateOfElement(number);
            if (amount >= 2) {
                Integer[] indexes = getIndexsOfElements(number);
                i = indexes[indexes.length - 1];
            } else {
                newArr[index] = (Integer)array[i];
                index++;
            }
        }
        return newArr;
    }
    public Integer[] createEmptyArrayWithOutDuplicatesNotExact(Integer maxNumberOfDuplications){
        int removeAmount = 0;
        for(int i = 0; i < array.length; i ++){
            Integer[] indexes = getIndexsOfElements((Integer)array[i]);
            if(indexes.length >= maxNumberOfDuplications) {
                removeAmount += indexes.length;
                i = indexes[indexes.length - 1];
            }
        }
        return new Integer[array.length - removeAmount];
    }

    public Integer[] getIndexsOfElements(Integer element){
        Integer[] indexes = new Integer[findDuplicateOfElement(element)];
        for(int i = 0; i < indexes.length; i ++){
            for(int j = 0; j < array.length; j ++){
                if(array[j].equals(element)){
                    if(!containsIndex(indexes, j)){
                        indexes[i] = j;
                        break;
                    }
                }
            }
        }
        return indexes;
    }

    public boolean containsIndex(Integer[] arr, Integer element){
        for(Integer integer : arr){
            if(integer != null) {
                if (integer.equals(element)) {
                    return true;
                }
            }
        }
        return false;
    }

    public int findDuplicateOfElement(int element){
        int count = 0;
        for(T i : array){
            if(i.equals(element)){
                count ++;
            }
        }
        return count;
    }
    public Double find2ndLargestValueFromArray() {
        Double arr[] = new Double[array.length];
        for(int i = 0; i < array.length; i ++){
            if(array[i] instanceof Double){
                arr[i] = (Double) array[i];
            }
        }
        Arrays.sort(arr);
        return arr[arr.length -2];
    }
    public List<T> makeMeAnArrayListFromArray() {
        return Arrays.asList(array);
    }
    public Integer[] makeMeAnArrayFromArrayList(List<Integer> test) {
        return test.toArray(new Integer[test.size()]);
    }
    public boolean isEqual(T[] test02) {
        boolean equal = false;
        for(int i = 0; i < array.length; i ++){
            if(array[i].equals(test02[i])){
                equal = true;
            } else {
                equal = false;
                break;
            }
        }
        return equal;
    }
    public Integer[] convertToIntArray(){
        Integer[] newArr = new Integer[array.length];
        for(int i = 0; i < array.length; i ++){
            Integer element = (Integer) array[i];
            newArr[i] = element;
        }
        return newArr;
    }
    public Integer[] convertToIntArray(T[] array){
        Integer[] newArr = new Integer[array.length];
        for(int i = 0; i < array.length; i ++){
            Integer element = (Integer) array[i];
            newArr[i] = element;
        }
        return newArr;
    }
    public Double averageArrayWithoutMaxMin() {
        Integer[] newArr = convertToIntArray();
        Arrays.sort(newArr);
        Integer[] findAvg = Arrays.copyOfRange(newArr, 1, newArr.length-1);
        return avgInteger(findAvg);
    }
    public boolean arrayHas65and77() {
        return contains(65) && contains(77);
    }
    public boolean theTotalofTensIs30() {
        Integer tenTotal = 0;
        for(int i = 0; i < array.length; i ++){
            Integer number = (Integer) array[i];
            if(number % 10 == 0){
                tenTotal += number;
            }
        }
        return tenTotal % 30 == 0;
    }
    public SmallestSecondSmallest findSmallestSecondSmallest() {
        Integer[] newArr = convertToIntArray();
        Arrays.sort(newArr);
        return new SmallestSecondSmallest(newArr[0], newArr[1]);
    }
    public Integer[] makeMeACopyPlease() {
        Integer[] newArr = convertToIntArray();
        return reverse(newArr);
    }
    public Integer[] removeLastItemAndCopy() {
        T[] newArr = removeElement(array[array.length - 1]);
        return convertToIntArray(newArr);
    }
    public Integer[] removeFirstItemAndCopy() {
        T[] newArr = removeElement(array[0]);
        return convertToIntArray(newArr);
    }
    public T[] insertFirstItemAndCopy(T i) {
        T[] newArr = insertElement(0, i);
        return newArr;
    }
    public T[] insertAtEndAndCopy(T i) {
        T[] newArr = insertElement(array.length, i);
        return newArr;
    }
    public Integer[] sortArrayIntoEvensThenOdds() {
        OddEven type = getOddEvenes();
        Integer[] odds = new Integer[type.getOdds()];
        int oddIndex = 0;
        Integer[] even = new Integer[type.getEvens()];
        int evenIndex = 0;
        for(int i = 0; i < array.length; i ++){
            Integer number = (Integer) array[i];
            if(number % 2 == 0){
                even[evenIndex] = number;
                evenIndex++;
            } else {
                odds[oddIndex] = number;
                oddIndex ++;
            }
        }
        return merge(even, odds);
    }
    public Integer[] merge(Integer[] array1, Integer[] array2) {
        Integer[] result = Arrays.copyOf(array1, array1.length + array2.length);
        System.arraycopy(array2, 0, result, array1.length, array2.length);
        return result;
    }
}

