import junit.framework.Assert;
import org.junit.Test;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ArrazTest {

//     * sum values of an array of integers sumValuesOfArray
        @Test
        public void test01SumIntegerValues(){
            Integer[] test = {0, 1, 1, 2, 3, 4};
            Arraz<Integer> arr = new Arraz(test);
            Integer expect = 11;
            Integer actual = arr.sumInteger();

            Assert.assertEquals(expect, actual);
        }

        @Test
        public void test02SumIntegerValues(){
            Integer[] test = {0, 1, 1, 2, 3, 4, 4, 4, 5, 6, 1, 2, 3, 4};
            Arraz<Integer> arr = new Arraz(test);
            Integer expect = 40;
            Integer actual = arr.sumInteger();

            Assert.assertEquals(expect, actual);
        }

//     * sum values of an array of doubles sumDoublesOfArray
        @Test
        public void test01SumDoubleValues(){
            Double[] test = {.5, .5,.5, .5,.5, .5,.5, .5,.5, .5,.5, .5,.5, .5,.5, .5,.5, .5,};
            Arraz<Double> arr = new Arraz(test);
            Double expect = 9.0;
            Double actual = arr.sumDouble();

            Assert.assertEquals(expect, actual);
        }

        @Test
        public void test02SumDoubleValues(){
            Double[] test = {0.4, 1.6, 1.5};
            Arraz<Double> arr = new Arraz(test);
            double expect = 3.5;
            double actual = arr.sumDouble();

            Assert.assertEquals(expect, actual);
        }

//     * calculate the average value of an integer array - return an integer averageOfArray
        @Test
        public void test01AvgIntegerValues(){
            Integer[] test = {0, 1, 2, 2, 3, 4};
            Arraz<Integer> arr = new Arraz(test);
            Integer expect = 2;
            Integer actual = arr.avgInteger();

            Assert.assertEquals(expect, actual);
        }

        @Test
        public void test02AvgIntegerValues(){
            Integer[] test = {5, 5, 5, 5, 5};
            Arraz<Integer> arr = new Arraz(test);
            Integer expect = 5;
            Integer actual = arr.avgInteger();

            Assert.assertEquals(expect, actual);
        }

//     * calculate the average value of an double array - return an double doubleAverageOfArray
        @Test
        public void test01doubleAverageOfArray(){
            Double[] test = {.5, .5, .5, .5, .5, .5};
            Arraz<Double> arr = new Arraz(test);
            double expect = .5;
            double actual = arr.avgDouble();

            Assert.assertEquals(expect, actual);
        }

        @Test
        public void test02doubleAverageOfArray(){
            Double[] test = {.17, .13, .25, .25, .5};
            Arraz<Integer> arr = new Arraz(test);
            double expect = .26;
            double actual = arr.avgDouble();

            Assert.assertEquals(expect, actual);
        }
//     * to test if an integer array contains a specific value, pass both array and value as arguments containsValue
        @Test
        public void test01IntegerContains(){
            Integer[] test = {4,5,102,6,-7,12,-32,92,8};
            Arraz<Integer> arr = new Arraz(test);
            Assert.assertTrue(arr.contains(5));
        }

        @Test
        public void test02IntegerContains(){
            Integer[] test = {4,5,102,6,-7,12,-32,92,8};
            Arraz<Integer> arr = new Arraz(test);
            Assert.assertFalse(arr.contains(19));
        }

//     * reverse an array of integer values reverseArray
    @Test
    public void test01IntegerReverse(){
        Integer[] test = {4,5,102,6,-7,12,-32,92,8};
        Arraz<Integer> arr = new Arraz(test);
        Integer[] expect = {8, 92, -32, 12, -7, 6, 102, 5, 4};
        Integer[] actual = arr.reverse();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02IntegerReverse(){
        Integer[] test = {1, 2, 3, 4, 5};
        Integer[] expect = {5, 4, 3, 2, 1};
        Arraz<Integer> arr = new Arraz(test);
        Integer[] actual = arr.reverse();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * find the number of even and odd integers in a given array of integers getOddEvensOfArray, return an object of type OddEven
    @Test
    public void getEventOdds01(){
        Integer[] test = {0, 1, 2, 3, 4, 5, 6};
        Arraz<Integer> arr = new Arraz(test);
        OddEven expect = new OddEven(3, 4);
        OddEven actual = arr.getOddEvenes();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void getEventOdds02(){
        Integer[] test = {0, 18, 92, 83, -13, 45};
        Arraz<Integer> arr = new Arraz(test);
        OddEven expect = new OddEven(3, 3);
        OddEven actual = arr.getOddEvenes();
        Assert.assertEquals(expect, actual);
    }
//     * find the index of an array element, pass both array and value as arguments findIndexOf
    @Test
    public void test01IndexOf(){
       String[] test = {"aba", "abab", "abbaba"};
       Arraz<String> arr = new Arraz<String>(test);
       Assert.assertTrue(arr.indexOf("aba") == 0);
    }

    @Test
    public void test02IndexOf(){
        Integer[] test = {0, 1, 2};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertTrue(arr.indexOf(1) == 1);
    }
//     * copy an array by iterating the array copyArrayByInterator
    @Test
    public void test01IteratorCopy(){
        Integer[] test = {0, 1, 2};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] expect = {0, 1, 2};
        Integer[] actual = arr.copyIterator();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02IteratorCopy(){
        Integer[] test = {0, 1, 2, 5, 9, 7, 1, 3};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] expect = {0, 1, 2, 5, 9, 7, 1, 3};
        Integer[] actual = arr.copyIterator();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * copy an array by looping thru the array copyArrayByLoop
    @Test
    public void test01LoopCopy(){
        Integer[] test = {0, 1, 2, 5, 9, 7, 1, 3};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] expect = {0, 1, 2, 5, 9, 7, 1, 3};
        Integer[] actual = arr.copyLoop();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02LoopCopy(){
        Integer[] test = {0, 1, 2};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] expect = {0, 1, 2};
        Integer[] actual = arr.copyLoop();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }
//     * remove a specific element from an array removeElementFromArray
    @Test
    public void test01RemoveElement(){
        String[] test = {"aba", "abba", "abba", "abaaba"};
        String[] expect = {"aba", "abba", "abaaba"};
        Arraz<String> arr = new Arraz<String>(test);
        String[] actual = arr.removeElement("abba");
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02RemoveElement(){
        Integer[] test = {0, 1, 1, 2, 3};
        Integer[] expect = {0, 1, 2, 3};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeElement(1);
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }
//     * insert an element into an array a specific position insertIntoArrayAt
    @Test
    public void test01InsertElement(){
        String[] test = {"aba", "abba", "abba", "abaaba"};
        String[] expect = {"aba", "abba","abba", "abba", "abaaba"};
        Arraz<String> arr = new Arraz<String>(test);
        String[] actual = arr.insertElement(1, "abba");
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02InsertElement(){
        Integer[] test = {0, 1, 1, 2, 3};
        Integer[] expect = {0, 5, 1, 1, 2, 3};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.insertElement(1, 5);
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }
//     * find the maximum and minimum value of an array findMaxMinOfArray return a MaxMin
    @Test
    public void test01FindMinMax(){
       Integer[] test = {0, 1, 2, 3, 4, 5, 3, 2};
       MaxMin expect = new MaxMin(5, 0);
       Arraz<Integer> arr = new Arraz<Integer>(test);
       MaxMin actual = arr.getMaxMin();
       Assert.assertEquals(expect, actual);
    }

    @Test
    public void test02FindMinMax(){
        Integer[] test = {0, 1, 2, 3, 4, 5, 3, 2, 9, 17, -32, 5};
        MaxMin expect = new MaxMin(17, -32);
        Arraz<Integer> arr = new Arraz<Integer>(test);
        MaxMin actual = arr.getMaxMin();
        Assert.assertEquals(expect, actual);
    }
//     * remove duplicate elements from an array, return new array removeDupesFromArray (make it an array of Integers)
    @Test
    public void test01RemoveDuplicates(){
        Integer[] test  = {0, 1, 1, 2, 3, 3, 4, 4, 5, 6};
        Integer[] expect = {0, 2, 5, 6};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeDuplicates();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02RemoveDuplicates(){
        Integer[] test  = {0, 1, 2, 1, 2, 3, 3, 4, 4, 5, 6};
        Integer[] expect = {0, 5, 6};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeDuplicates();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }
//     * find the second largest element in an array of Doubles find2ndLargestValueFromArray
    @Test
    public void test01find2ndLargestValueFromArray(){
        Double[] test = {0.0, .1, .223, .54, -.9};
        Double expect = .223;
        Arraz<Double> arr = new Arraz<Double>(test);
        Double actual = arr.find2ndLargestValueFromArray();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test02find2ndLargestValueFromArray(){
        Double[] test = {0.0, .1, .223, .54, -.9, .224, .93};
        Double expect = .54;
        Arraz<Double> arr = new Arraz<Double>(test);
        Double actual = arr.find2ndLargestValueFromArray();
        Assert.assertEquals(expect, actual);
    }
//     * convert an array to ArrayList makeMeAnArrayListFromArray
    @Test
    public void test01makeMeAnArrayListFromArray(){
        Integer[] test = {0, 1, 2, 3, 4, 5};
        List<Integer> expect = new ArrayList<Integer>();
        expect.add(0);expect.add(1);expect.add(2);expect.add(3);expect.add(4);expect.add(5);
        Arraz<Integer> arr = new Arraz<Integer>(test);
        List<Integer> actual = arr.makeMeAnArrayListFromArray();
        for(int i = 0; i < expect.size(); i ++){
            Assert.assertEquals(expect.get(i), actual.get(i));
        }
    }

    @Test
    public void test02makeMeAnArrayListFromArray(){
        Integer[] test = {5, 5, 7, 6, 2, 5, 7, -1};
        List<Integer> expect = new ArrayList<Integer>();
        expect.add(5);expect.add(5);expect.add(7);expect.add(6);expect.add(2);expect.add(5);expect.add(7);expect.add(-1);
        Arraz<Integer> arr = new Arraz<Integer>(test);
        List<Integer> actual = arr.makeMeAnArrayListFromArray();
        for(int i = 0; i < expect.size(); i ++){
            Assert.assertEquals(expect.get(i), actual.get(i));
        }
    }

//     * convert an ArrayList to an array makeMeAnArrayFromArrayList
    @Test
    public void test01makeMeAnArrayFromArrayList(){
        List<Integer> test = new ArrayList<Integer>();
        test.add(5);test.add(5);test.add(7);test.add(6);test.add(2);test.add(5);test.add(7);test.add(-1);
        Integer[] expect = {5, 5, 7, 6, 2, 5, 7, -1};
        Arraz<Integer> arr = new Arraz<Integer>();
        Integer[] actual = arr.makeMeAnArrayFromArrayList(test);
        System.out.println(Arrays.toString(actual));
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02makeMeAnArrayFromArrayList(){
        List<Integer> test = new ArrayList<Integer>();
        test.add(0);test.add(1);test.add(2);test.add(3);test.add(4);test.add(5);
        Integer[] expect = {0, 1, 2, 3, 4, 5};
        Arraz<Integer> arr = new Arraz<Integer>();
        Integer[] actual = arr.makeMeAnArrayFromArrayList(test);
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }
//     * test the equality of two arrays check2ArraysForEqual
    @Test
    public void test01check2ArraysForEqual(){
        Integer[] test = {0, 1, 2, 3, 4, 5};
        Integer[] test02 = {0, 1, 2, 3, 4, 5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertTrue(arr.isEqual(test02));
    }

    @Test
    public void test02check2ArraysForEqual(){
        String[] test = {"aba", "aabab", "ababa"};
        String[] test02 = {"aba", "ababa"};
        Arraz<String> arr = new Arraz<String>(test);
        Assert.assertFalse(arr.isEqual(test02));
    }

//     * compute the average value of an array of integers except the largest and smallest values (be thinking of code re-use for this one) averageArrayWithoutMaxMin
    @Test
    public void test01averageArrayWithoutMaxMin(){
        Integer[] test = {0, 2, 4, 2, 4, 5};
        double expect = 3;
        Arraz<Integer> arr = new Arraz<Integer>(test);
        double actual = arr.averageArrayWithoutMaxMin();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test02averageArrayWithoutMaxMin(){
        Integer[] test = {0, -1, 2, 13, 45, 2};
        double expect = 4.25;
        Arraz<Integer> arr = new Arraz<Integer>(test);
        double actual = arr.averageArrayWithoutMaxMin();
        Assert.assertEquals(expect, actual);
    }

//     * check if an array of integers contains two specified elements: 65 and 77, returns a boolean arrayHas65and77
    @Test
    public void test01arrayHas65and77(){
        Integer[] test = {0, 1, 2, 3, 65, 4, 5, 77};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertTrue(arr.arrayHas65and77());
    }

    @Test
    public void test02arrayHas65and77(){
        Integer[] test = {0, 1, 2, 3, 4, 5, 77};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertFalse(arr.arrayHas65and77());
    }

//     * check if the sum of all the 10's in the array is exactly 30. Return false if the condition does not satisfy, otherwise true. theTotalofTensIs30
    @Test
    public void test01theTotalofTensIs30(){
        Integer[] test = {10, 10, 10, 5, 4, 2, 6};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertTrue(arr.theTotalofTensIs30());
    }

    @Test
    public void test02theTotalofTensIs30(){
        Integer[] test = {10, 10, 10, 10, 5, 4, 2, 6};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Assert.assertFalse(arr.theTotalofTensIs30());
    }

//     * find smallest and second smallest elements of a given array
    @Test
    public void test01findSmallestSecondSmallest(){
        Integer[] test = {0, 1, 2, 3, 4, 5};
        SmallestSecondSmallest expect = new SmallestSecondSmallest(0, 1);
        Arraz<Integer> arr = new Arraz<Integer>(test);
        SmallestSecondSmallest actual = arr.findSmallestSecondSmallest();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void test02findSmallestSecondSmalled(){
        Integer[] test = {0, 5, 2, 3, 4, 5};
        SmallestSecondSmallest expect = new SmallestSecondSmallest(0, 2);
        Arraz<Integer> arr = new Arraz<Integer>(test);
        SmallestSecondSmallest actual = arr.findSmallestSecondSmallest();
        Assert.assertEquals(expect, actual);
    }

//     * copy an array of integers, reverse it, and return it. makeMeACopyPlease
    @Test
    public void test01makeMeACopyPlease(){
        Integer[] test = {0, 1, 2, 3, 4, 5};
        Integer[] expect = {5, 4, 3, 2, 1};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.makeMeACopyPlease();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02makeMeACopyPlease(){
        Integer[] test = {0, 3, 2, 5, 6, 5};
        Integer[] expect = {5, 6, 5, 2, 3, 0};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.makeMeACopyPlease();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * remove the last element from an array of integers, return a copy removeLastItemAndCopy
    @Test
    public void test01removeLastItemAndCopy(){
        Integer[] test = {0, 1, 2, 3, 4, 5};
        Integer[] expect = {0, 1, 2, 3, 4};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeLastItemAndCopy();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02removeLastItemAndCopy(){
        Integer[] test = {0, 1, 2, 3, 4, -5};
        Integer[] expect = {0, 1, 2, 3, 4};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeLastItemAndCopy();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }


//     * remove the first element from an array of integers, return a copy removeFirstItemAndCopy
    @Test
    public void test01removeFirstItemAndCopy(){
        Integer[] test = {0, 1, 2, 3, 4, -5};
        Integer[] expect = {1, 2, 3, 4, -5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeFirstItemAndCopy();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02removeFirstItemAndCopy(){
        Integer[] test = {-5, 1, 2, 3, 4, -5};
        Integer[] expect = {1, 2, 3, 4, -5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.removeFirstItemAndCopy();
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * insert a new element at the start of an array, return a copy insertAtStartAndCopy
    @Test
    public void test01insertAtStartAndCopy(){
        Integer[] test = {1, 1, 2, 3, 4, -5};
        Integer[] expect = {1, 1, 1, 2, 3, 4, -5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.insertFirstItemAndCopy(1);
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02insertAtStartAndCopy(){
        Integer[] test = {1, 1, 2, 3, 4, -5};
        Integer[] expect = {16, 1, 1, 2, 3, 4, -5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.insertFirstItemAndCopy(16);
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * insert a new element at the end of an array, return a copy insertAtEndAndCopy
    @Test
    public void test01insertAtEndAndCopy(){
        Integer[] test = {1, 1, 2, 3, 4, -5};
        Integer[] expect = { 1, 1, 2, 3, 4, -5, 16};
        System.out.println(Arrays.toString(expect));
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.insertAtEndAndCopy(16);
        System.out.println(Arrays.toString(actual));
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

    @Test
    public void test02insertAtEndAndCopy(){
        String[] test = {"a", "b", "c"};
        String[] expect = {"a", "b", "c", "d"};
        Arraz<String> arr = new Arraz<String>(test);
        String[] actual = arr.insertAtEndAndCopy("d");
        for(int i = 0; i < expect.length; i ++){
            Assert.assertEquals(expect[i], actual[i]);
        }
    }

//     * separate even and odd numbers of an given array of integers. Put all even numbers first, and then odd numbers sortArrayIntoEvensThenOdds
    @Test
    public void test01sortArrayIntoEvensThenOdds(){
        Integer[] test = {0, 1, 2, 3, 4, 5, 6};
        Integer[] expect = {0, 2, 4, 6, 1, 3, 5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.sortArrayIntoEvensThenOdds();
    }

    @Test
    public void test02sortArrayIntoEvensThenOdds(){
        Integer[] test = {0, -1, 2, 3, 4, -5, -6};
        Integer[] expect = {0, 2, 4, -6, -1, 3, -5};
        Arraz<Integer> arr = new Arraz<Integer>(test);
        Integer[] actual = arr.sortArrayIntoEvensThenOdds();
        System.out.println(Arrays.toString(actual));
    }
}